(function ($) {
Drupal.gmap.tag1_rebound = function(e) {
  var url = '/geom/bbox/' + $(this).val();
  $.getJSON(url, function(data, status) {
    // @@@ Centralize and unbork.
    var re = /([0-9.\-]+) ([0-9.\-]+)/g;
    var st = new String(data.wkt);
    var match;
    var points = [];
    while ((match = re.exec(st))) {
      points.push(new GLatLng(Number(match[2]),Number(match[1])));
    }
    var poly = new GPolygon(points);
    Drupal.gmap.globalChange('changeBBOX', poly.getBounds());

    // Hack to pull up surroundings
    var btn;
    if ((btn = document.getElementById('ml_surround_button'))) {
      GEvent.trigger(btn, 'click');
    }
  });
}

Drupal.behaviors.phase1_rebound = function (context) {
  // @@@ What will this be when HS takes over?
  $('#edit-field-state-nid-nid', context)
  .add('#edit-field-water-nid-nid', context)
  .not('.phase1-rebound-preprocessed')
  .addClass('phase1-rebound-preprocessed')
  .change(Drupal.gmap.tag1_rebound)
};


Drupal.gmap.addHandler('gmap', function (elem) {
  var obj = this;
  obj.bind('changeBBOX', function(bounds) {
    obj.map.setCenter(bounds.getCenter(), obj.map.getBoundsZoomLevel(bounds));
  });
  obj.bind('ready', function(elem) {
    // @@@ Double check this...
    Drupal.gmap.tag1_rebound.call($('#edit-field-water-nid-nid'));
  });
});

})(jQuery);
